<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml">
    <!-- params: currentOrder = the current order in the table
                   displayEncounterInfo : displays the column with the encounter info if set to true
                   enableStatusEdit: if true enable the user to change result status and order status
                   managedBean: if enableStatusEdit = true
                   sectionToReRender: if enableStatusEdit = true-->
    <g:column>
        <ui:define name="header">#{messages['gazelle.ordermanager.OrderNumbers']}</ui:define>
        <dl class="dl-horizontal">
            <s:decorate template="/layout/display/_data_list_item.xhtml" rendered="#{not empty currentOrder.placerOrderNumber}">
                <ui:define name="label">
                    <s:div>
                        <h:outputText value="#{messages['gazelle.ordermanager.Placer']}"
                                      rendered="#{not (currentOrder.simulatedActor.keyword.equals('ANALYZER') or currentOrder.simulatedActor.keyword.equals('ANALYZER_MGR'))}"/>
                        <h:outputText value="#{messages['gazelle.ordermanager.AWOSID']}"
                                      rendered="#{currentOrder.simulatedActor.keyword.equals('ANALYZER') or currentOrder.simulatedActor.keyword.equals('ANALYZER_MGR')}"/>
                    </s:div>
                </ui:define>
                <h:outputText value="#{currentOrder.placerOrderNumber}"/>
            </s:decorate>
            <s:decorate template="/layout/display/_data_list_item.xhtml" rendered="#{not empty currentOrder.fillerOrderNumber}">
                <ui:define name="label">
                    <s:div>
                        <h:outputText value="#{messages['gazelle.ordermanager.Filler']}"
                                      rendered="#{not (currentOrder.simulatedActor.keyword.equals('ANALYZER') or currentOrder.simulatedActor.keyword.equals('ANALYZER_MGR'))}"/>
                        <h:outputText value="#{messages['gazelle.ordermanager.ParentAWOSID']}"
                                      rendered="#{currentOrder.simulatedActor.keyword.equals('ANALYZER') or currentOrder.simulatedActor.keyword.equals('ANALYZER_MGR')}"/>
                    </s:div>
                </ui:define>
                <h:outputText value="#{currentOrder.fillerOrderNumber}"/>
            </s:decorate>
        </dl>
    </g:column>
    <g:column rendered="#{displayEncounterInfo}">
        <ui:define name="header">#{messages['gazelle.ordermanager.EncounterInformation']}</ui:define>
        <dl class="dl-horizontal">
            <s:decorate template="/layout/display/_data_list_item.xhtml">
                <ui:define name="label">#{messages['gazelle.ordermanager.VisitNumber']}</ui:define>
                <h:outputText value="#{currentOrder.encounter.visitNumber}"/>
            </s:decorate>
            <s:decorate template="/layout/display/_data_list_item.xhtml">
                <ui:define name="label">#{messages['gazelle.ordermanager.Patient']}</ui:define>
                <h:outputText
                        value="#{currentOrder.encounter.patient.firstName} #{currentOrder.encounter.patient.lastName}"/>
            </s:decorate>
        </dl>
    </g:column>
    <g:column filterBy="#{'orderControlCode'}" sortBy="#{'orderControlCode'}" filterEvent="onkeyup"
              filterValue="#{dataTableStateHolder.columnFilterValues['orderControlCode']}">
        <ui:define name="header">#{messages['gazelle.ordermanager.ControlCode']}</ui:define>
        <h:outputText value="#{currentOrder.orderControlCode}"/>
    </g:column>
    <g:column filterBy="#{'orderStatus'}" sortBy="#{'orderStatus'}" filterEvent="onkeyup"
              filterValue="#{dataTableStateHolder.columnFilterValues['orderStatus']}"
              rendered="#{not enableStatusEdit}">
        <ui:define name="header">#{messages['gazelle.ordermanager.Status']}</ui:define>
        <h:outputText value="#{currentOrder.orderStatus}"/>
    </g:column>
    <!-- Edit the order status (ORC-5) -->
    <g:column rendered="#{enableStatusEdit}" id="orderStatusColumn">
        <ui:define name="header">#{messages['gazelle.ordermanager.Status']}</ui:define>
        <h:outputText value="#{currentOrder.orderStatus}"/>
        <gdk:spacer width="5px"/>
        <a4j:commandButton value="#{messages['gazelle.ordermanager.Update']}"
                           actionListener="#{managedBean.setSelectedOrderId(currentOrder.id)}"
                           rendered="#{managedBean.selectedOrderId == null}" render="orderStatusColumn"/>
        <s:decorate template="/layout/edit.xhtml" rendered="#{managedBean.selectedOrderId.equals(currentOrder.id)}">
            <ui:define name="label">#{messages['gazelle.ordermanager.NewOrderStatus']}</ui:define>
            <h:selectOneMenu value="#{managedBean.newOrderStatus}">
                <f:selectItems value="#{valueSet.getListOfConcepts('orderStatus')}"/>
                <a4j:ajax event="change"
                          render="#{sectionToReRender}" listener="#{managedBean.updateOrder(currentOrder)}"
                          />
            </h:selectOneMenu>
        </s:decorate>
    </g:column>
    <!-- Edit the result status (OBR-25) -->
    <g:column id="orderResultStatusColumn" rendered="#{enableStatusEdit}">
        <ui:define name="header">#{messages['gazelle.ordermanager.ResultStatus']}</ui:define>
        <h:outputText value="#{currentOrder.orderResultStatus}"/>
        <gdk:spacer width="5px"/>
        <a4j:commandButton value="#{messages['gazelle.ordermanager.Update']}"
                           actionListener="#{managedBean.setSelectedOrderId(currentOrder.id)}"
                           rendered="#{displayAddButton and managedBean.selectedOrderId == null}"
                           render="orderResultStatusColumn"/>
        <s:decorate template="/layout/edit.xhtml" rendered="#{managedBean.selectedOrderId.equals(currentOrder.id)}">
            <ui:define name="label">#{messages['gazelle.ordermanager.NewResultStatus']}</ui:define>
            <h:selectOneMenu value="#{managedBean.newResultStatus}">
                <f:selectItems value="#{valueSet.getListOfConcepts('resultStatus')}"/>
                <a4j:ajax event="change"
                          render="#{sectionToReRender}" listener="#{managedBean.updateOrder(currentOrder)}"
                          />
            </h:selectOneMenu>
        </s:decorate>
    </g:column>
    <g:column filterBy="#{'universalServiceId'}" sortBy="#{'universalServiceId'}" filterEvent="onkeyup"
              filterValue="#{dataTableStateHolder.columnFilterValues['universalServiceId']}">
        <ui:define name="header">#{messages['gazelle.ordermanager.UniversalServiceId']}</ui:define>
        <h:outputText value="#{currentOrder.universalServiceId}"/>
    </g:column>
    <g:column sortBy="#{'lastChanged'}" sortOrder="descending">
        <ui:define name="header">#{messages['gazelle.ordermanager.LastChanged']}</ui:define>
        <g:date value="#{currentOrder.lastChanged}"/>
    </g:column>
    <g:column filterBy="#{'creator'}" sortBy="#{'creator'}" filterEvent="onkeyup"
              filterValue="#{dataTableStateHolder.columnFilterValues['creator']}">
        <ui:define name="header">#{messages['gazelle.ordermanager.Creator']}</ui:define>
        <h:outputText value="#{currentOrder.creator}"/>
    </g:column>
</ui:composition>
